# -*- coding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2009 CamptoCamp. All rights reserved.
#    @author Nicolas Bessi
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields
from openerp.osv.orm import Model


class audittrail_log(Model):
    _inherit = 'audittrail.log'

    def _get_source(self, cr, uid, ids, fields, args, context=None):
        res = {}
        for obj in self.browse(cr, uid, ids, context):
            res[obj.id] = False
            model = self.pool.get(obj.object_id.model)
            resource = model.browse(cr, uid, obj.res_id, context)
            if hasattr(resource, 'origin'):
                res[obj.id] = resource.origin
            elif hasattr(resource, 'name'):
                res[obj.id] = resource.name
        return res

    _columns = {
        'source': fields.function(_get_source, method=True, type='char',
                                  size=128, string='Source')
    }


