# -*- coding: utf-8 -*-

import re
import time
import xlwt
from report import report_sxw
from report_engine_xls import report_xls


class ReportStatus(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context=None):
        super(ReportStatus, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
        })


class balance_sheet_xls(report_xls):

    def generate_xls_report(self, parser, data, obj, wb):
        ws = wb.add_sheet(('Balance Sheet'))
        ws.panes_frozen = True
        ws.remove_splits = True
        ws.portrait = 0  # Landscape
        ws.fit_width_to_pages = 1

        cols_specs = [
            ('Account Code', 1, 70, 'text', lambda x, d, p: x[0]),
            ('Account Name', 1, 120, 'text', lambda x, d, p: x[1]),
            ('Ending Balance', 1, 100, 'text', lambda x, d, p: x[2]),
        ]

        style = xlwt.easyxf('pattern: pattern solid, fore_colour light_blue;')
        title = self.xls_row_template(cols_specs, ['Account Code', 'Account Name', 'Ending Balance'])
        self.xls_write_row_header(ws, 0, title, style, set_column_size=True)

        row_count = 1
        for x in data['csv']:
            ws.write(row_count, 0, x[0])
            ws.write(row_count, 1, x[1])
            ws.write(row_count, 2, x[2])
            row_count += 1

        pass


# balance_sheet_xls('report.balance.sheet.excel', 'account.move',
#                   parser=ReportStatus, header=False)
balance_sheet_xls('report.balance.sheet.excel', 'account.move', './report_excel.mako',
parser = ReportStatus, header = False)
