# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010, 2014 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields, osv


class black_list_constraint(osv.osv):
    _name = 'black.list.constraint'
    _description = 'Black List Constraint'

    _columns = {
        'user_id': fields.many2one('res.users', 'User', required=True, ondelete='cascade'),
        'model_id': fields.many2one('ir.model', 'Object', required=True, ondelete='cascade'),
        'company_id': fields.many2one('res.company', 'Company', required=True, ondelete='cascade'),
    }

    _sql_constraints = [
        ('record_unique', 'UNIQUE(company_id,model_id,user_id)', 'The payment line name must be unique!'),
    ]

    _defaults = {
        'company_id': lambda self, cr, uid, context: self.pool.get('res.company')._company_default_get(cr, uid, 'black.list.constraint', context=context)
    }
