# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010, 2014 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields, osv


class black_list_constraint_payment(osv.osv):
    _name = 'black.list.constraint'
    _inherit = 'black.list.constraint'
    _description = 'Black List Constraint'

    def _object_default_get(self, cr, uid, object=False, context=None):
        """
        """
        if not context:
            context = {}
        model_obj = self.pool.get('ir.model')

        id_model_voucher = model_obj.search(cr, uid, [('model', '=', object)], context=context)[0]
        return id_model_voucher

    _columns = {
        'model_id': fields.many2one('ir.model', 'Object', required=True, ondelete='cascade'),
    }

    _defaults = {
        'model_id': lambda self, cr, uid, context: self._object_default_get(cr, uid, 'account.voucher', context=context),
    }
