# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010, 2014 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields, osv
from openerp.osv.orm import Model
from openerp import netsvc


class res_partner(Model):
    _name = 'res.partner'
    _inherit = 'res.partner'

    def _total_deposit_get(self, cr, uid, ids, field_names, arg, context=None):
        ctx = context.copy()
        # ctx['all_fiscalyear'] = True
        query = self.pool.get('account.move.line')._query_get(cr, uid, context=ctx)
        res = {}
        for rec in self.browse(cr, uid, ids, context=context):
            cr.execute("""SELECT l.partner_id, SUM(l.debit-l.credit)
                          FROM account_move_line l
                          LEFT JOIN account_account a ON (l.account_id=a.id)
                          WHERE a.type IN ('payable')
                          AND l.partner_id=%s
                          AND l.account_id=%s
                          AND """ + query + """
                          GROUP BY l.partner_id
                          """,
                       (rec.id, rec.account_supplier_deposit_id.id))
            val = cr.fetchone()
            res[rec.id] = val and val[1] or 0.0
        return res

    def _get_invoice(self, cr, uid, ids, context=None):
        """copy pasted from account_invoice"""
        result = {}
        for line in self.pool.get('account.invoice').browse(cr, uid, ids, context=context):
            if line.state in ('open','cancel'):
                result[line.partner_id.id] = True
        return result.keys()

    def _get_move(self, cr, uid, ids, context=None):
        """copy pasted from account_invoice"""
        result = {}
        for line in self.pool.get('account.move.line').browse(cr, uid, ids, context=context):
            result[line.partner_id.id] = True
        return result.keys()

    def _get_invoice_line(self, cr, uid, ids, context=None):
        """copy pasted from account_invoice"""
        result = {}
        for line in self.pool.get('account.invoice.line').browse(cr, uid, ids, context=context):
            result[line.partner_id.id] = True
        return result.keys()

    _columns = {
        'debit_limit': fields.float('Payable Limit'),
        'debit_deposit': fields.function(_total_deposit_get, string='Total Deposit', help="Total amount that you subtract of the deposit to the supplier.",
            store={
                'res.partner': (lambda self, cr, uid, ids, c={}: ids, ['credit', 'debit', 'debit_limit', 'debit_deposit'], 20),
                'account.invoice': (_get_invoice, ['partner_id', 'state'], 20),
                'account.move.line': (_get_move, ['partner_id'], 20),
              },),
    }