# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010, 2014 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields
from openerp.osv.orm import Model


class destination_category(Model):
    _name = 'destination.category'
    _columns = {
        'code': fields.char('Code', size=8),
        'name': fields.char('Name', size=128),
    }


class destination(Model):
    _name = 'destination'
    _columns = {
        'code': fields.char('Code', size=8),
        'name': fields.char('Name', size=128),
        'description': fields.text('Description'),
        'parent_id': fields.many2one('destination', 'Parent'),
        'child_ids': fields.one2many('destination', 'parent_id', 'Children'),
        'category_ids': fields.many2many('destination.category',
                                         'destination_category_rel',
                                         'destination_id', 'category_id',
                                         'Categories')
    }


class destination_distance(Model):
    _name = 'destination.distance'
    _columns = {
        'origin': fields.many2one('destination', 'Origin'),
        'target': fields.many2one('destination', 'Target'),
        'distance': fields.float('Distance')
    }
