# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010, 2014 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields
from openerp.osv.orm import Model


class option_type(Model):
    _name = 'option.type'
    _columns = {
        'name': fields.char('Name', size=32, translate=True),
        'code': fields.char('Code', size=32),
        'option_value_ids': fields.one2many('option.value', 'option_type_id',
                                            'Option Values')
    }


class option_value(Model):
    _name = 'option.value'
    _columns = {
        'name': fields.char('Name', size=32, translate=True),
        'code': fields.char('Code', size=32),
        'option_type_id': fields.many2one('option.type', 'Option Type')
    }

    def get_value_by_code(self, cr, uid, code, context=None):
        value = self.search(cr, uid, [('code', '=', code)], context=context)
        return value and value[0] or False
