# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010, 2014 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields
from openerp.osv.orm import Model


class product_flight(Model):
    _name = 'product.flight'
    _inherits = {'product.product': 'product_id'}
    _inherit = ['mail.thread']
    _columns = {
        'product_id': fields.many2one('product.product', 'Product',
                                      required=True, ondelete="cascade"),
        'origin': fields.many2one('destination', 'Origin'),
        'to': fields.many2one('destination', 'To'),
        'flight_name': fields.related('product_id', 'name', type='char',
                                      string='Name', size=128, select=True,
                                      store=True),
    }

    _order = 'flight_name asc'

    def price_get_partner(self, cr, uid, cls, to_search, params, context=None):
        price = 0.0
        model = self.pool.get(cls)
        pp_ids = model.search(cr, uid, to_search, context=context)
        if pp_ids:
            value = model.browse(cr, uid, pp_ids[0], context)
            price = value.price * params.get('adults', 0) + \
                    value.child * params.get('children', 0)
        return price
