# -*- coding: utf-8 -*-

import re
import time
import xlwt
from report import report_sxw
from report_engine_xls import report_xls


class ReportStatus(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context=None):
        super(ReportStatus, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
        })


class balance_sheet_xls(report_xls):

    def generate_xls_report(self, parser, data, obj, wb):

        if data['form'].items()[0][1]['date_from'] and data['form'].items()[0][1]['date_to']:
            sheet_name = 'Ceiba GS' + data['form'].items()[0][1]['date_from'] + 'to' + \
                         data['form'].items()[0][1]['date_to']
        else:
            if data['form'].items()[0][1]['period_from'] and data['form'].items()[0][1]['period_to']:
                sheet_name = 'Ceiba GS' + data['form'].items()[0][1]['date_currency_from'] + 'to' + data['form'].items()[0][1][
                    'date_currency_to']

        sheet_name2 = 'Ceiba GC month rate'

        ws = wb.add_sheet(sheet_name, cell_overwrite_ok=True)
        ws2 = wb.add_sheet(sheet_name2, cell_overwrite_ok=True)

        ws.panes_frozen = True
        ws.remove_splits = True
        ws.portrait = 0  # Landscape
        ws.fit_width_to_pages = 1

        ws2.panes_frozen = True
        ws2.remove_splits = True
        ws2.portrait = 0  # Landscape
        ws2.fit_width_to_pages = 1

        if data['form'].items()[0][1]['date_from'] and data['form'].items()[0][1]['date_to']:
            ws.write(1, 0, 'Date From:')
            ws.write(1, 1, data['form'].items()[0][1]['date_from'])
            ws.write(1, 2, 'Date To:')
            ws.write(1, 3, data['form'].items()[0][1]['date_to'])
        else:
            if data['form'].items()[0][1]['period_from'] and data['form'].items()[0][1]['period_to']:
                ws.write(1, 0, 'Period From:')
                ws.write(1, 1, data['form'].items()[0][1]['date_currency_from'])
                ws.write(1, 2, 'Period To:')
                ws.write(1, 3, data['form'].items()[0][1]['date_currency_to'])

        cols_specs = [
            ('Concept', 7, 70, 'text', lambda x, d, p: x[0]),
            ('Amount', 1, 120, 'text', lambda x, d, p: x[7]),
            ('Opening Balance/Adjustment', 1, 120, 'text', lambda x, d, p: x[8]),
            ('Current Year/Adjustment', 1, 120, 'text', lambda x, d, p: x[9]),
            ('Final', 1, 100, 'text', lambda x, d, p: x[10]),
        ]

        style = xlwt.easyxf('pattern: pattern solid, fore_colour orange;')
        style2 = xlwt.easyxf('pattern: pattern solid, fore_colour yellow;')

        title = self.xls_row_template(cols_specs,
                                      ['Concept', 'Amount', 'Opening Balance/Adjustment', 'Current Year/Adjustment',
                                       'Final'])

        self.xls_write_row_header(ws, 3, title, style, set_column_size=True)
        # self.xls_write_row_header(ws2, 3, title, style, set_column_size=True)

        row_count = 5
        row_count2 = 4
        column = 0

        for x in data['csv']:
            ws.row(row_count).level = x['level']
            ws.write(row_count, x['level'], x['name'])
            ws.write(row_count, 7, x['balance'])
            ws.write(row_count, 10, x['balance'])
            # ws.write(row_count, 2, x[2])
            row_count += 1
        for x in data['lines_profit_loss']:
            ws.row(row_count).level = x['level']
            ws.write(row_count, x['level'], x['name'])
            ws.write(row_count, 7, x['balance'])
            ws.write(row_count, 10, x['balance'])
            # ws.write(row_count, 2, x[2])
            row_count += 1

        # sheet 2
        cols_specs2 = [('Month', 1, 70, 'text', lambda x, d, p: x[0])]
        data_name = ['Month']
        pos = 1
        for dat in data['currency_name']:
            cols = (dat, 1, 70, 'text', lambda x, d, p: x[pos])
            cols_specs2.append(cols)
            data_name.append(dat)
            pos += 1
        end = [('CHF-rate', 7, 70, 'text', lambda x, d, p: x[pos])]
        cols_specs2.append(end)
        data_name.append('CHF-rate')

        title2 = self.xls_row_template(cols_specs2, data_name)
        self.xls_write_row_header(ws2, 3, title2, style, set_column_size=True)

        month = {
            '01': 'January',
            '02': 'February',
            '03': 'March',
            '04': 'April',
            '05': 'May',
            '06': 'June',
            '07': 'July',
            '08': 'August',
            '09': 'September',
            '10': 'October',
            '11': 'November',
            '12': 'December'}
        month_name = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October',
                      'November', 'December']
        i = 4

        sorted(data['currency_month'], key=lambda x: x['month'])  # esto es para ordenar una lista de diccionarios
        # sorted(month)  # esto es para ordenar una lista de diccionarios
        for m in month_name:
            ws2.write(i, 0, m)
            i += 1
        for x in data['currency_month']:
            ws2.write(int(x['month'])+3, data_name.index(x['currency_id'][1]), x['month_rate'])

    pass


balance_sheet_xls('report.balance.sheet.finantial.excel', 'account.move',
                  '/mnt/extra-addons/gs-travel/export_excel/report/report_excel.mako',
                  parser=ReportStatus, header=False)
