# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010, 2014 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import datetime
from openerp.osv import fields
from openerp.osv.orm import Model


class res_partner(Model):
    _name = 'res.partner'
    _inherit = 'res.partner'


    _columns = {
        'property_account_rappel': fields.property(
            'account.account',
            type='many2one',
            relation='account.account',
            string="Account rappels",
            view_load=True,
            domain="[('type', '=', 'other')]",
            help="This account will be used instead of the default one as the rappel account for the current partner",
            required=False),
    }