# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010, 2014 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv.orm import Model


class sale_order(Model):
    _inherit = 'sale.order'

    def create(self, cr, uid, vals, context=None):
        if vals.get('name', '/') == '/':
            irs = self.pool.get('ir.sequence')
            vals['name'] = irs.get(cr, uid, 'sale.order.draft') or '/'
        return super(sale_order, self).create(cr, uid, vals, context=context)

    def write(self, cr, uid, ids, vals, context=None):
        if vals.get('state', False) == 'manual':
            for obj in self.browse(cr, uid, ids, context):
                wals = vals.copy()
                if obj.name.startswith('DF'):
                    irs = self.pool.get('ir.sequence')
                    wals['origin'] = obj.name
                    wals['name'] = irs.get(cr, uid, 'sale.order') or '/'
                super(sale_order, self).write(cr, uid, [obj.id], wals, context)
            res = True
        else:
            res = super(sale_order, self).write(cr, uid, ids, vals, context)
        return res
